Attribute VB_Name = "ModRGB"
Option Explicit

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias _
        "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal _
        ByteLen As Long)


Private Type OLECOLOR
   RedOrSys As Byte
   Green As Byte
   Blue As Byte
   Type As Byte
End Type


Function WinColor(VBColor As Long) As Long
   Dim SysClr As OLECOLOR

   CopyMemory SysClr, VBColor, Len(SysClr)

   If SysClr.Type = &H80 Then 'Es ist eine Systemfarbe
      WinColor = GetSysColor(SysClr.RedOrSys)
   Else 'Es ist keine Systemfarbe
      WinColor = VBColor
   End If
End Function

Public Function lR(ByVal Color As Long) As Byte
   CopyMemory lR, WinColor(Color), 1
End Function

Public Function lG(ByVal Color As Long) As Byte
   CopyMemory lG, ByVal VarPtr(WinColor(Color)) + 1, 1
End Function

Public Function lB(ByVal Color As Long) As Byte
   CopyMemory lB, ByVal VarPtr(WinColor(Color)) + 2, 1
End Function

